/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: aux.h,v $
 * Revision 1.1.2.14  1995/10/02  21:29:04  John_Dennis
 * 	{** Merge Information **}
 * 		{** Command used:	bsubmit **}
 * 		{** Ancestor revision:	1.1.2.12 **}
 * 		{** Merge revision:	1.1.2.13 **}
 * 	{** End **}
 * 	bring up to SGI 1.0.16 sample release
 * 	[1995/08/15  21:36:21  John_Dennis]
 *
 * Revision 1.1.2.13  1995/09/19  15:44:55  Andy_Vesper
 * 	Make auxInitDisplayModeID return void to match the routine
 * 	which doesn't return anything.
 * 	Change `GLvoid' to `void' in prototypes for auxXDisplay and
 * 	auxXWindow.
 * 	[1995/09/19  14:45:30  Andy_Vesper]
 * 
 * Revision 1.1.2.12  1995/04/24  15:19:43  John_Dennis
 * 	bring files up to SGI 1.0.15 release
 * 	[1995/04/24  15:14:54  John_Dennis]
 * 
 * Revision 1.1.2.11  1994/09/12  23:10:35  John_Dennis
 * 	add missing extern to auxGetScreenNumber & auxGetContext
 * 	add #include <GL/glx.h>
 * 	[1994/09/12  23:10:04  John_Dennis]
 * 
 * Revision 1.1.2.10  1994/09/12  20:43:24  John_Dennis
 * 	add auxGetScreenNumber & auxGetContext
 * 	[1994/09/12  20:42:34  John_Dennis]
 * 
 * Revision 1.1.2.9  1994/09/11  13:19:34  John_Dennis
 * 	add in VPAUX changes
 * 	[1994/09/11  13:14:50  John_Dennis]
 * 
 * Revision 1.1.2.8  1994/05/17  20:15:11  John_Dennis
 * 	updated to SGI release 1.0.13
 * 	[1994/05/17  20:12:57  John_Dennis]
 * 
 * Revision 1.1.2.7  1994/05/16  15:29:40  John_Dennis
 * 	add auxWindowType()
 * 	[1994/05/16  15:22:28  John_Dennis]
 * 
 * Revision 1.1.2.6  1994/04/21  21:40:44  John_Dennis
 * 	made C++ safe
 * 	[1994/04/21  21:28:15  John_Dennis]
 * 
 * Revision 1.1.2.5  1994/04/05  17:42:07  John_Dennis
 * 	change AUX_STENCIL value to match TK_STENCIL
 * 	[1994/04/05  17:41:33  John_Dennis]
 * 
 * Revision 1.1.2.4  1993/11/11  21:28:09  Andy_Vesper
 * 	 	Get rid of the extern for auxRGBMap; it isn't needed and it
 * 	 	make the VMS DEC C compiler barf.
 * 	[1993/11/11  21:27:36  Andy_Vesper]
 * 
 * Revision 1.1.2.3  1993/11/10  20:52:42  Andy_Vesper
 * 	Change two occurances of GLvoid to void; this makes the DEC C (VMS)
 * 	compiler happier.
 * 	[1993/11/10  19:43:14  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1993/10/07  20:10:44  John_Dennis
 * 	new files in SGI OpenGL 1.0.11 release
 * 	[1993/10/07  18:44:13  John_Dennis]
 * 
 * $EndLog$
 */
#ifndef __aux_h__
#define __aux_h__

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <GL/gl.h>
#include <GL/glu.h>

#ifdef DEC
#if defined(__cplusplus)
extern "C" {
#endif
#endif
/*
** ToolKit Window Types
** In the future, AUX_RGBA may be a combination of both RGB and ALPHA
*/

#define AUX_RGB		0
#define AUX_RGBA	AUX_RGB
#define AUX_INDEX	1
#define AUX_SINGLE	0
#define AUX_DOUBLE	2
#define AUX_DIRECT	0
#define AUX_INDIRECT	4

#define AUX_ACCUM	8
#define AUX_ALPHA	16
#define AUX_DEPTH	32
#define AUX_STENCIL	512
#define AUX_AUX		128


/* 
** Window Masks
*/

#define AUX_WIND_IS_RGB(x)	(((x) & AUX_INDEX) == 0)
#define AUX_WIND_IS_INDEX(x)	(((x) & AUX_INDEX) != 0)
#define AUX_WIND_IS_SINGLE(x)	(((x) & AUX_DOUBLE) == 0)
#define AUX_WIND_IS_DOUBLE(x)	(((x) & AUX_DOUBLE) != 0)
#define AUX_WIND_IS_INDIRECT(x)	(((x) & AUX_INDIRECT) != 0)
#define AUX_WIND_IS_DIRECT(x)	(((x) & AUX_INDIRECT) == 0)
#define AUX_WIND_HAS_ACCUM(x)	(((x) & AUX_ACCUM) != 0)
#define AUX_WIND_HAS_ALPHA(x)	(((x) & AUX_ALPHA) != 0)
#define AUX_WIND_HAS_DEPTH(x)	(((x) & AUX_DEPTH) != 0)
#define AUX_WIND_HAS_STENCIL(x)	(((x) & AUX_STENCIL) != 0)

/*
** Display Mode Selection Criteria
*/

enum {
    AUX_USE_ID = 1,
    AUX_EXACT_MATCH,
    AUX_MINIMUM_CRITERIA
};


/*
** ToolKit Event Structure
*/

typedef struct _AUX_EVENTREC {
    GLint event;
    GLint data[4];
} AUX_EVENTREC;

/* 
** ToolKit Event Types
*/
#define AUX_EXPOSE	1
#define AUX_CONFIG	2
#define AUX_DRAW	4
#define AUX_KEYEVENT	8
#define AUX_MOUSEDOWN	16
#define AUX_MOUSEUP	32	
#define AUX_MOUSELOC	64

/*
** Toolkit Event Data Indices
*/
#define AUX_WINDOWX		0
#define AUX_WINDOWY		1
#define AUX_MOUSEX		0
#define AUX_MOUSEY		1
#define AUX_MOUSESTATUS		3
#define AUX_KEY			0
#define AUX_KEYSTATUS		1

/*
** ToolKit Event Status Messages
*/
#define	AUX_LEFTBUTTON		1
#define	AUX_RIGHTBUTTON		2
#define	AUX_MIDDLEBUTTON	4
#define	AUX_SHIFT		1
#define	AUX_CONTROL		2

/* 
** ToolKit Key Codes
*/
#define AUX_RETURN		0x0D
#define AUX_ESCAPE		0x1B
#define AUX_SPACE		0x20
#define AUX_LEFT		0x25
#define AUX_UP			0x26
#define AUX_RIGHT		0x27
#define AUX_DOWN		0x28
#define AUX_A			'A'
#define AUX_B			'B'
#define AUX_C			'C'
#define AUX_D			'D'
#define AUX_E			'E'
#define AUX_F			'F'
#define AUX_G			'G'
#define AUX_H			'H'
#define AUX_I			'I'
#define AUX_J			'J'
#define AUX_K			'K'
#define AUX_L			'L'
#define AUX_M			'M'
#define AUX_N			'N'
#define AUX_O			'O'
#define AUX_P			'P'
#define AUX_Q			'Q'
#define AUX_R			'R'
#define AUX_S			'S'
#define AUX_T			'T'
#define AUX_U			'U'
#define AUX_V			'V'
#define AUX_W			'W'
#define AUX_X			'X'
#define AUX_Y			'Y'
#define AUX_Z			'Z'
#define AUX_a			'a'
#define AUX_b			'b'
#define AUX_c			'c'
#define AUX_d			'd'
#define AUX_e			'e'
#define AUX_f			'f'
#define AUX_g			'g'
#define AUX_h			'h'
#define AUX_i			'i'
#define AUX_j			'j'
#define AUX_k			'k'
#define AUX_l			'l'
#define AUX_m			'm'
#define AUX_n			'n'
#define AUX_o			'o'
#define AUX_p			'p'
#define AUX_q			'q'
#define AUX_r			'r'
#define AUX_s			's'
#define AUX_t			't'
#define AUX_u			'u'
#define AUX_v			'v'
#define AUX_w			'w'
#define AUX_x			'x'
#define AUX_y			'y'
#define AUX_z			'z'
#define AUX_0			'0'
#define AUX_1			'1'
#define AUX_2			'2'
#define AUX_3			'3'
#define AUX_4			'4'
#define AUX_5			'5'
#define AUX_6			'6'
#define AUX_7			'7'
#define AUX_8			'8'
#define AUX_9			'9'

/*
** ToolKit Gets and Sets
*/
#define AUX_FD			1  /* return fd (long) */
#define AUX_COLORMAP		3  /* pass buf of r, g and b (unsigned char) */
#define AUX_GREYSCALEMAP	4
#define AUX_FOGMAP		5  /* pass fog and color bits (long) */
#define AUX_ONECOLOR		6  /* pass index, r, g, and b (long) */

/*
** Color Macros
*/

enum {
    AUX_BLACK = 0,
    AUX_RED,
    AUX_GREEN,
    AUX_YELLOW,
    AUX_BLUE,
    AUX_MAGENTA,
    AUX_CYAN,
    AUX_WHITE
};

#ifndef DEC
extern float auxRGBMap[8][3];
#endif

#define AUX_SETCOLOR(x, y) (AUX_WIND_IS_RGB((x)) ? \
		           glColor3fv(auxRGBMap[(y)]) : glIndexf((y)))

/*
** Prototypes
*/

extern void auxInitDisplayMode(GLenum);
extern void auxInitDisplayModePolicy( GLenum type);
#if defined(DEC) /* bug fix */
extern void auxInitDisplayModeID( GLint id);
#else
extern GLenum auxInitDisplayModeID( GLint id);
#endif
extern void auxInitPosition(int, int, int, int);
extern GLenum auxInitWindow(char *);
extern void auxCloseWindow(void);
extern void auxQuit(void);
extern void auxSwapBuffers(void);

#if defined(DEC) /* Bug fix -- ANSI C says `The special case of void ... */
extern Display *auxXDisplay(void);
extern Window auxXWindow(void);
#else
extern Display *auxXDisplay(GLvoid);
extern Window auxXWindow(GLvoid);
#endif
extern int auxXScreen(void);

extern void auxMainLoop(void (*)());
extern void auxExposeFunc(void (*)(int, int));
extern void auxReshapeFunc(void (*)(int, int));
extern void auxIdleFunc(void (*)());
extern void auxKeyFunc(int, void (*)());
extern void auxMouseFunc(int, int, void (*)(AUX_EVENTREC *));

extern int auxGetColorMapSize(void);
extern void auxGetMouseLoc(int *, int *);
extern GLenum auxGetDisplayModePolicy( void);
extern GLint auxGetDisplayModeID( void);
extern GLenum auxGetDisplayMode( void);
extern long auxGetCurrentContext(void);
extern void auxSetOneColor(int, float, float, float);
extern void auxSetFogRamp(int, int);
extern void auxSetGreyRamp(void);
extern void auxSetRGBMap(int, float *);

extern void auxWireSphere(GLdouble);
extern void auxSolidSphere(GLdouble);
extern void auxWireCube(GLdouble);
extern void auxSolidCube(GLdouble);
extern void auxWireBox(GLdouble, GLdouble, GLdouble);
extern void auxSolidBox(GLdouble, GLdouble, GLdouble);
extern void auxWireTorus(GLdouble, GLdouble);
extern void auxSolidTorus(GLdouble, GLdouble);
extern void auxWireCylinder(GLdouble, GLdouble);
extern void auxSolidCylinder(GLdouble, GLdouble);
extern void auxWireIcosahedron(GLdouble);
extern void auxSolidIcosahedron(GLdouble);
extern void auxWireOctahedron(GLdouble);
extern void auxSolidOctahedron(GLdouble);
extern void auxWireTetrahedron(GLdouble);
extern void auxSolidTetrahedron(GLdouble);
extern void auxWireDodecahedron(GLdouble);
extern void auxSolidDodecahedron(GLdouble);
extern void auxWireCone(GLdouble, GLdouble);
extern void auxSolidCone(GLdouble, GLdouble);
extern void auxWireTeapot(GLdouble);
extern void auxSolidTeapot(GLdouble);

#ifdef DEC
#if defined(__cplusplus)
}
#endif
#endif
#endif /* __aux_h__ */
