/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: glut_stroke.c,v $
 * Revision 1.1.2.3  1996/02/16  15:15:51  Andy_Vesper
 * 	Glut 3.0 for R6
 * 	[1996/02/16  14:00:26  Andy_Vesper]
 *
 * Revision 1.1.2.3  1996/02/12  15:43:15  Andy_Vesper
 * 	Glut 3.0
 * 	[1996/02/09  21:15:39  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1995/04/26  15:02:57  John_Dennis
 * 	new files from GLUT 2.1 release
 * 	[1995/04/25  15:51:03  John_Dennis]
 * 
 * $EndLog$
 */

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees
   and is provided without guarantee or warrantee expressed or
   implied. This program is -not- in the public domain. */

#include <GL/glut.h>
#include "glutint.h"
#include "glutstroke.h"

void
glutStrokeCharacter(GLUTstrokeFont font, int c)
{
  StrokeCharPtr ch;
  StrokePtr stroke;
  CoordPtr coord;
  StrokeFontPtr fontinfo = (StrokeFontPtr) font;
  int i, j;

  if (c < 0 || c >= fontinfo->num_chars)
    return;
  ch = &(fontinfo->ch[c]);
  if (ch) {
    for (i = ch->num_strokes, stroke = ch->stroke;
      i > 0; i--, stroke++) {
      glBegin(GL_LINE_STRIP);
      for (j = stroke->num_coords, coord = stroke->coord;
        j > 0; j--, coord++) {
        glVertex2f(coord->x, coord->y);
      }
      glEnd();
    }
    glTranslatef(ch->right, 0.0, 0.0);
  }
}
