/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: glut_util.c,v $
 * Revision 1.1.2.3  1996/02/16  15:16:05  Andy_Vesper
 * 	Glut 3.0 for R6
 * 	[1996/02/16  14:01:02  Andy_Vesper]
 *
 * Revision 1.1.2.3  1996/02/12  15:43:32  Andy_Vesper
 * 	Glut 3.0
 * 	[1996/02/09  21:16:44  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1995/04/26  15:03:28  John_Dennis
 * 	new files from GLUT 2.1 release
 * 	[1995/04/25  15:51:32  John_Dennis]
 * 
 * $EndLog$
 */

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees
   and is provided without guarantee or warrantee expressed or
   implied. This program is -not- in the public domain. */

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

#include <GL/glut.h>
#include "glutint.h"

void
__glutWarning(char *format,...)
{
  va_list args;

  va_start(args, format);
  fprintf(stderr, "GLUT: Warning in %s: ",
    __glutProgramName ? __glutProgramName : "(unamed)");
  vfprintf(stderr, format, args);
  va_end(args);
  putc('\n', stderr);
}

void
__glutFatalError(char *format,...)
{
  va_list args;

  va_start(args, format);
  fprintf(stderr, "GLUT: Fatal Error in %s: ",
    __glutProgramName ? __glutProgramName : "(unamed)");
  vfprintf(stderr, format, args);
  va_end(args);
  putc('\n', stderr);
  exit(1);
}

void
__glutFatalUsage(char *format,...)
{
  va_list args;

  va_start(args, format);
  fprintf(stderr, "GLUT: Fatal API Usage in %s: ",
    __glutProgramName ? __glutProgramName : "(unamed)");
  vfprintf(stderr, format, args);
  va_end(args);
  putc('\n', stderr);
  abort();
}
