/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: test1.c,v $
 * Revision 1.1.2.5  1996/03/07  20:45:38  Andy_Vesper
 * 	Glut v3.0 Feb 24, 1996
 * 	[1996/03/07  19:06:14  Andy_Vesper]
 *
 * Revision 1.1.2.4  1996/02/16  15:18:10  Andy_Vesper
 * 	Glut 3.0 for R6
 * 	[1996/02/16  14:07:48  Andy_Vesper]
 * 
 * Revision 1.1.2.4  1996/02/12  15:44:09  Andy_Vesper
 * 	Glut 3.0
 * 	[1996/02/09  20:57:31  Andy_Vesper]
 * 
 * Revision 1.1.2.3  1995/10/24  21:38:12  Andy_Vesper
 * 	Fix for OpenVMS
 * 	[1995/10/24  19:44:49  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1995/04/26  15:14:12  John_Dennis
 * 	new files from GLUT 2.1 release
 * 	[1995/04/25  16:00:36  John_Dennis]
 * 
 * $EndLog$
 */

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees 
   and is provided without guarantee or warrantee expressed or 
   implied. This program is -not- in the public domain. */

#ifdef __sgi
#include <malloc.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <glutint.h>

char *fake_argv[] =
{
  "program",
#ifndef DEC
  "-display",
  ":0",
#endif
  "-geometry",
  "500x400+34+23",
  "-indirect",
  "-iconic",
  NULL};

int fake_argc = sizeof(fake_argv) / sizeof(char *) - 1;

int
main(int argc, char **argv)
{
#if defined(__sgi)  && !defined(REDWOOD)
  /* XXX IRIX 6.0.1 mallopt(M_DEBUG, 1) busted. */
  mallopt(M_DEBUG, 1);
#endif
  glutInit(&fake_argc, fake_argv);
  if (fake_argc != 1) {
    __glutFatalError("FAIL: argument processing");
  }
  if (glutGet(GLUT_INIT_WINDOW_WIDTH) != 500) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_WINDOW_HEIGHT) != 400) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_WINDOW_X) != 34) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_WINDOW_Y) != 23) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_DISPLAY_MODE) !=
    (GLUT_RGBA | GLUT_SINGLE | GLUT_DEPTH)) {
    __glutFatalError("FAIL: width wrong");
  }
  glutInitWindowPosition(10, 10);
  glutInitWindowSize(200, 200);
  glutInitDisplayMode(
    GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH | GLUT_STENCIL);
  if (glutGet(GLUT_INIT_WINDOW_WIDTH) != 200) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_WINDOW_HEIGHT) != 200) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_WINDOW_X) != 10) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_WINDOW_Y) != 10) {
    __glutFatalError("FAIL: width wrong");
  }
  if (glutGet(GLUT_INIT_DISPLAY_MODE) !=
    (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH | GLUT_STENCIL)) {
    __glutFatalError("FAIL: width wrong");
  }
  printf("PASS: test1\n");
  return 0;             /* ANSI C requires main to return int. */
}
