/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: test14.c,v $
 * Revision 1.1.2.5  1996/03/07  20:45:50  Andy_Vesper
 * 	Glut v3.0 Feb 24, 1996
 * 	[1996/03/07  19:06:52  Andy_Vesper]
 *
 * Revision 1.1.2.4  1996/02/16  15:18:19  Andy_Vesper
 * 	Glut 3.0 for R6
 * 	[1996/02/16  14:08:16  Andy_Vesper]
 * 
 * Revision 1.1.2.4  1996/02/12  15:44:20  Andy_Vesper
 * 	Glut 3.0
 * 	[1996/02/09  20:58:11  Andy_Vesper]
 * 
 * Revision 1.1.2.3  1995/10/24  21:38:25  Andy_Vesper
 * 	Fix for OpenVMS
 * 	[1995/10/24  19:45:15  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1995/10/02  21:28:34  John_Dennis
 * 	new file in SGI OpenGL sample implementation Version 1.0.16
 * 	[1995/08/15  17:39:21  John_Dennis]
 * 
 * $EndLog$
 */

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees 
   and is provided without guarantee or warrantee expressed or 
   implied. This program is -not- in the public domain. */

/* Try testing menu item removal and menu destruction. */

#ifdef __sgi
#include <malloc.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>

void
displayFunc(void)
{
  glClear(GL_COLOR_BUFFER_BIT);
}

void
menuFunc(int choice)
{
  printf("choice = %d\n", choice);
}

void
timefunc(int value)
{
  if (value != 1) {
    printf("FAIL: test14\n");
    exit(1);
  }
  printf("PASS: test14\n");
  exit(0);
}

int
main(int argc, char **argv)
{
  int i, menu, submenu;

#if defined(__sgi)  && !defined(REDWOOD)
  /* XXX IRIX 6.0.1 mallopt(M_DEBUG, 1) busted. */
  mallopt(M_DEBUG, 1);
#endif
  glutInit(&argc, argv);
  glutCreateWindow("test14");
  glutDisplayFunc(displayFunc);

  submenu = glutCreateMenu(menuFunc);
  glutAddMenuEntry("First", 10101);
  glutAddMenuEntry("Second", 20202);

  menu = glutCreateMenu(menuFunc);
  glutAddMenuEntry("Entry1", 101);
  glutAddMenuEntry("Entry2----------", 102);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("oEntry1", 201);
  glutAddMenuEntry("o----------", 200);
  glutAddMenuEntry("oEntry2----------", 202);
  glutAddMenuEntry("oEntry3", 203);
  glutRemoveMenuItem(2);
  glutDestroyMenu(menu);

  menu = glutCreateMenu(menuFunc);
  glutAddMenuEntry("Entry1", 101);
  glutAddMenuEntry("Entry2----------", 102);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("oEntry1", 201);
  glutAddMenuEntry("o----------", 200);
  glutAddMenuEntry("oEntry2----------", 202);
  glutAddMenuEntry("oEntry3", 203);
  glutRemoveMenuItem(2);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

  menu = glutCreateMenu(menuFunc);
  for (i = 0; i < 10; i++) {
    glutAddMenuEntry("YES", i);
  }
  for (i = 0; i < 10; i++) {
    glutRemoveMenuItem(1);
  }
  glutAddMenuEntry("Entry1", 101);
  glutAddMenuEntry("Entry2", 102);
  glutAddMenuEntry("Entry3", 103);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("----------", 303);
  for (i = 0; i < 10; i++) {
    glutAddMenuEntry("YES**************************", i);
  }
  for (i = 0; i < 9; i++) {
    glutRemoveMenuItem(3);
  }
  glutDestroyMenu(menu);

  menu = glutCreateMenu(menuFunc);
  for (i = 0; i < 10; i++) {
    glutAddMenuEntry("YES", i);
  }
  for (i = 0; i < 10; i++) {
    glutRemoveMenuItem(1);
  }
  glutAddMenuEntry("Entry1", 101);
  glutAddMenuEntry("Entry2", 102);
  glutAddMenuEntry("Entry3", 103);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("----------", 303);
  for (i = 0; i < 10; i++) {
    glutAddMenuEntry("YES**************************", i);
  }
  for (i = 0; i < 9; i++) {
    glutRemoveMenuItem(3);
  }
  glutAttachMenu(GLUT_MIDDLE_BUTTON);

  menu = glutCreateMenu(menuFunc);
  glutAddMenuEntry("Entry1", 101);
  glutAddMenuEntry("Entry2", 102);
  glutAddMenuEntry("Entry3", 103);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("nEntry1", 201);
  glutAddMenuEntry("nEntry2----------", 202);
  glutAddMenuEntry("nEntry3", 203);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("n----------", 303);
  glutChangeToMenuEntry(1, "HELLO", 34);
  glutChangeToSubMenu(2, "HELLO menu", submenu);
  glutDestroyMenu(menu);

  menu = glutCreateMenu(menuFunc);
  glutAddMenuEntry("Entry1", 101);
  glutAddMenuEntry("Entry2", 102);
  glutAddMenuEntry("Entry3", 103);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("nEntry1", 201);
  glutAddMenuEntry("nEntry2----------", 202);
  glutAddMenuEntry("nEntry3", 203);
  glutRemoveMenuItem(2);
  glutRemoveMenuItem(1);
  glutAddMenuEntry("n----------", 303);
  glutAttachMenu(GLUT_LEFT_BUTTON);

  glutTimerFunc(2000, timefunc, 1);

  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
