/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: test15.c,v $
 * Revision 1.1.2.5  1996/03/07  20:45:52  Andy_Vesper
 * 	Glut v3.0 Feb 24, 1996
 * 	[1996/03/07  19:07:05  Andy_Vesper]
 *
 * Revision 1.1.2.4  1996/02/16  15:18:21  Andy_Vesper
 * 	Glut 3.0 for R6
 * 	[1996/02/16  14:08:22  Andy_Vesper]
 * 
 * Revision 1.1.2.4  1996/02/12  15:44:23  Andy_Vesper
 * 	Glut 3.0
 * 	[1996/02/09  20:58:20  Andy_Vesper]
 * 
 * Revision 1.1.2.3  1995/10/24  21:38:27  Andy_Vesper
 * 	Fix for OpenVMS
 * 	[1995/10/24  19:45:20  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1995/10/02  21:28:37  John_Dennis
 * 	new file in SGI OpenGL sample implementation Version 1.0.16
 * 	[1995/08/15  17:39:37  John_Dennis]
 * 
 * $EndLog$
 */

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees 
   and is provided without guarantee or warrantee expressed or 
   implied. This program is -not- in the public domain. */

/* This test makes sure that if you post a redisplay within a
   display callback, another display callback will be
   generated. I believe this is useful for progressive
   refinement of an image.  Draw it once at a coarse
   tesselation to get something on the screen; then redraw at a
   higher level of tesselation.  Pre-GLUT 2.3 fails this test. */

#ifdef __sgi
#include <malloc.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>

GLfloat light_diffuse[] =
{1.0, 0.0, 0.0, 1.0};
GLfloat light_position[] =
{1.0, 1.0, 1.0, 0.0};
GLUquadricObj *qobj;

void
displayFunc(void)
{
  static int tesselation = 3;

  fprintf(stderr, " %d", tesselation);
  if (tesselation > 23) {
    printf("\nPASS: test15\n");
    exit(0);
  }
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  gluSphere(qobj, /* radius */ 1.0,
    /* slices */ tesselation, /* stacks */ tesselation);
  glutSwapBuffers();
  tesselation += 1;
  glutPostRedisplay();
}

void
timefunc(int value)
{
  printf("\nFAIL: test15\n");
  exit(1);
}

int
main(int argc, char **argv)
{
#if defined(__sgi)  && !defined(REDWOOD)
  /* XXX IRIX 6.0.1 mallopt(M_DEBUG, 1) busted. */
  mallopt(M_DEBUG, 1);
#endif
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGB);
  glutCreateWindow("test15");
  glutDisplayFunc(displayFunc);

  qobj = gluNewQuadric();
  gluQuadricDrawStyle(qobj, GLU_FILL);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  gluPerspective( /* field of view in degree */ 22.0,
  /* aspect ratio */ 1.0,
    /* Z near */ 1.0, /* Z far */ 10.0);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(0.0, 0.0, 5.0,  /* eye is at (0,0,5) */
    0.0, 0.0, 0.0,      /* center is at (0,0,0) */
    0.0, 1.0, 0.);      /* up is in postivie Y direction */
  glTranslatef(0.0, 0.0, -1.0);

  /* Have a reasonably large timeout since some machines make
     take a while to render all those polygons. */
  glutTimerFunc(15000, timefunc, 1);

  fprintf(stderr, "tesselations =");
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
