/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: test3.c,v $
 * Revision 1.1.2.5  1996/03/07  20:46:06  Andy_Vesper
 * 	Glut v3.0 Feb 24, 1996
 * 	[1996/03/07  19:07:59  Andy_Vesper]
 *
 * Revision 1.1.2.4  1996/02/16  15:18:38  Andy_Vesper
 * 	Glut 3.0 for R6
 * 	[1996/02/16  14:08:56  Andy_Vesper]
 * 
 * Revision 1.1.2.4  1996/02/12  15:44:42  Andy_Vesper
 * 	Glut 3.0
 * 	[1996/02/09  20:59:15  Andy_Vesper]
 * 
 * Revision 1.1.2.3  1995/10/24  21:38:33  Andy_Vesper
 * 	Fix for OpenVMS
 * 	[1995/10/24  19:45:32  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1995/04/26  15:14:37  John_Dennis
 * 	new files from GLUT 2.1 release
 * 	[1995/04/25  16:01:01  John_Dennis]
 * 
 * $EndLog$
 */

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees 
   and is provided without guarantee or warrantee expressed or 
   implied. This program is -not- in the public domain. */

#ifdef __sgi
#include <malloc.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <glutint.h>

#define N 6
#define M 6

int exposed[M * N];
int ecount = 0;
int viewable[M * N];
int vcount = 0;

void
display(void)
{
  int win;

  win = glutGetWindow() - 1;
  if (!exposed[win]) {
    exposed[win] = 1;
    ecount++;
  }
  glClear(GL_COLOR_BUFFER_BIT);
  if ((ecount == (M * N)) && (vcount == (M * N))) {
    printf("PASS: test3\n");
    exit(0);
  }
}

void
view(int state)
{
  int win;

  win = glutGetWindow() - 1;
  if (!viewable[win]) {
    viewable[win] = 1;
    vcount++;
  }
  if ((ecount == (M * N)) && (vcount == (M * N))) {
    printf("PASS: test3\n");
    exit(0);
  }
}

void
timer(int value)
{
  if (value != 23)
    __glutFatalError("FAIL: bad timer value");
  __glutFatalError("FAIL: didn't get all expose and viewable calls in 10 seconds");
}

int
main(int argc, char **argv)
{
  char buf[100];
  int i, j;

#if defined(__sgi)  && !defined(REDWOOD)
  /* XXX IRIX 6.0.1 mallopt(M_DEBUG, 1) busted. */
  mallopt(M_DEBUG, 1);
#endif
  glutInit(&argc, argv);
  glutInitWindowSize(10, 10);
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
  for (i = 0; i < M; i++) {
    for (j = 0; j < N; j++) {
      exposed[i * N + j] = 0;
      viewable[i * N + j] = 0;
      glutInitWindowPosition(100 * i, 100 * j);
      sprintf(buf, "%d\n", i * N + j + 1);
      glutCreateWindow(buf);
      glutDisplayFunc(display);
      glutVisibilityFunc(view);
      glClearColor(1.0, 0.0, 0.0, 1.0);
    }
  }
  /* XXX Hopefully in 45 seconds, all the windows should
     appear, or they probably won't ever appear! */
  glutTimerFunc(45 * 1000, timer, 23);
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
