/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: test4.c,v $
 * Revision 1.1.2.5  1996/03/07  20:46:08  Andy_Vesper
 * 	Glut v3.0 Feb 24, 1996
 * 	[1996/03/07  19:08:07  Andy_Vesper]
 *
 * Revision 1.1.2.4  1996/02/16  15:18:40  Andy_Vesper
 * 	Glut 3.0 for R6
 * 	[1996/02/16  14:09:02  Andy_Vesper]
 * 
 * Revision 1.1.2.4  1996/02/12  15:44:44  Andy_Vesper
 * 	Glut 3.0
 * 	[1996/02/09  20:59:26  Andy_Vesper]
 * 
 * Revision 1.1.2.3  1995/10/24  21:38:35  Andy_Vesper
 * 	Fix for OpenVMS
 * 	[1995/10/24  19:45:37  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1995/04/26  15:14:42  John_Dennis
 * 	new files from GLUT 2.1 release
 * 	[1995/04/25  16:01:06  John_Dennis]
 * 
 * $EndLog$
 */

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees 
   and is provided without guarantee or warrantee expressed or 
   implied. This program is -not- in the public domain. */

#ifdef __sgi
#include <malloc.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
#include <glutint.h>

int ch = -2;
void *font = GLUT_STROKE_ROMAN;

void
tick(void)
{
  ch += 1;
  if (ch > 180) {
    if (font == GLUT_STROKE_MONO_ROMAN) {
      printf("PASS: test4\n");
      exit(0);
    }
    ch = -2;
    font = GLUT_STROKE_MONO_ROMAN;
  }
  glutPostRedisplay();
}

void
display(void)
{
  glutIdleFunc(tick);
  glClear(GL_COLOR_BUFFER_BIT);
  glPushMatrix();
  glutStrokeCharacter(font, ch);
  glPopMatrix();
  glutSwapBuffers();
}

int
main(int argc, char **argv)
{
#if defined(__sgi)  && !defined(REDWOOD)
  /* XXX IRIX 6.0.1 mallopt(M_DEBUG, 1) busted. */
  mallopt(M_DEBUG, 1);
#endif
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(200, 200);
  glutCreateWindow("Test stroke fonts");
  if (glutGet(GLUT_WINDOW_COLORMAP_SIZE) != 0) {
    __glutFatalError("FAIL: bad RGBA colormap size");
  }
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(-50, 150, -50, 150);
  glClearColor(0.0, 0.0, 0.0, 1.0);
  glColor3f(1.0, 1.0, 1.0);
  glutDisplayFunc(display);
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
