/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: cursor.c,v $
 * Revision 1.1.2.4  1994/01/21  17:05:06  John_Dennis
 * 	brought file up to SGI 1.0.12 release
 * 	[1994/01/21  14:32:11  John_Dennis]
 *
 * Revision 1.1.2.3  1993/11/16  21:31:47  Andy_Vesper
 * 	Add casts for buf in two calls to XCreatePixmapsFromBitmapData.
 * 	[1993/11/16  21:11:49  Andy_Vesper]
 * 
 * Revision 1.1.2.2  1993/10/07  20:11:48  John_Dennis
 * 	new files in SGI OpenGL 1.0.11 release
 * 	[1993/10/07  18:46:46  John_Dennis]
 * 
 * $EndLog$
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tk.h"
#include "private.h"

/******************************************************************************/

#define MAX_CURSOR 32

typedef struct _cursorRec {
    GLint id;
    Cursor cursor;
} cursorRec;

int cursorNum = 0;
cursorRec cursors[MAX_CURSOR];

/******************************************************************************/

void tkNewCursor(GLint id, GLubyte *shapeBuf, GLubyte *maskBuf, GLenum fgColor,
		 GLenum bgColor, GLint hotX, GLint hotY)
{
    GLubyte buf[32];
    Pixmap shapeMap, maskMap;
    XColor c1, c2;
    int i;

    if (cursorNum == MAX_CURSOR-1) {
	return;
    }

    for (i = 0; i < 32; i += 2) {
	buf[i] = shapeBuf[i+1];
	buf[i+1] = shapeBuf[i];
    }
#ifdef DEC
    shapeMap = XCreatePixmapFromBitmapData(xDisplay, wRoot, (char *) buf, 16, 16,
					   1, 0, 1);
#else
    shapeMap = XCreatePixmapFromBitmapData(xDisplay, wRoot, buf, 16, 16,
					   1, 0, 1);
#endif
    for (i = 0; i < 32; i += 2) {
	buf[i] = maskBuf[i+1];
	buf[i+1] = maskBuf[i];
    }
#ifdef DEC
    maskMap = XCreatePixmapFromBitmapData(xDisplay, wRoot, (char *) buf, 16, 16,
					  1, 0, 1);
#else
    maskMap = XCreatePixmapFromBitmapData(xDisplay, wRoot, buf, 16, 16,
					  1, 0, 1);
#endif
    c1.red = (unsigned short)(tkRGBMap[fgColor][0] * 65535.0 + 0.5);
    c1.green = (unsigned short)(tkRGBMap[fgColor][1] * 65535.0 + 0.5);
    c1.blue = (unsigned short)(tkRGBMap[fgColor][2] * 65535.0 + 0.5);
    c1.flags = DoRed | DoGreen | DoBlue;
    c2.red = (unsigned short)(tkRGBMap[bgColor][0] * 65535.0 + 0.5);
    c2.green = (unsigned short)(tkRGBMap[bgColor][1] * 65535.0 + 0.5);
    c2.blue = (unsigned short)(tkRGBMap[bgColor][2] * 65535.0 + 0.5);
    c2.flags = DoRed | DoGreen | DoBlue;

    cursors[cursorNum].id = id;
    cursors[cursorNum].cursor = XCreatePixmapCursor(xDisplay, shapeMap, maskMap,
					            &c1, &c2, hotX, hotY);
    cursorNum++;
}

/******************************************************************************/

void tkSetCursor(GLint id)
{
    int i;

    for (i = 0; i < cursorNum; i++) {
	if (cursors[i].id == id) {
	    XDefineCursor(xDisplay, w.wMain, cursors[i].cursor);
	}
    }
}

/******************************************************************************/
