/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: private.h,v $
 * Revision 1.1.2.5  1995/04/24  15:19:58  John_Dennis
 * 	bring files up to SGI 1.0.15 release
 * 	[1995/04/24  15:15:15  John_Dennis]
 *
 * Revision 1.1.2.4  1994/09/11  13:19:46  John_Dennis
 * 	add in VPAUX changes
 * 	[1994/09/11  13:15:13  John_Dennis]
 * 
 * Revision 1.1.2.3  1994/01/21  17:05:26  John_Dennis
 * 	brought file up to SGI 1.0.12 release
 * 	[1994/01/21  14:32:43  John_Dennis]
 * 
 * Revision 1.1.2.2  1993/10/07  20:12:32  John_Dennis
 * 	new files in SGI OpenGL 1.0.11 release
 * 	[1993/10/07  18:48:07  John_Dennis]
 * 
 * $EndLog$
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <GL/glx.h>

#if defined(__cplusplus) || defined(c_plusplus)
#define class c_class
#endif


typedef struct _WINDOW_REC {
    int x, y, w, h;
    GLenum type;
    GLenum dmPolicy;
    Window wMain, wOverlay;
    XVisualInfo *vInfoMain, *vInfoOverlay;
    Colormap cMapMain, cMapOverlay;
    GLXContext cMain, cOverlay;
} WINDOW_REC;


extern Display *xDisplay;
extern int xScreen; 
extern Window wRoot;
extern WINDOW_REC w;
extern Atom deleteWindowAtom;

extern void (*ExposeFunc)(int, int);
extern void (*ReshapeFunc)(int, int);
extern void (*DisplayFunc)(void);
extern GLenum (*KeyDownFunc)(int, GLenum);
extern GLenum (*MouseDownFunc)(int, int, GLenum);
extern GLenum (*MouseUpFunc)(int, int, GLenum);
extern GLenum (*MouseMoveFunc)(int, int, GLenum);
extern void (*IdleFunc)(void);

extern GLenum drawAllowFlag;

extern int cursorNum;

